stages:
- copy

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_TLS_CERTDIR: ""

.copy:
  image: luktom/ws
  stage: copy
  services:
  - docker:dind
  script:
  - |
      export INIT_AWS_ACCESS_KEY_ID=$AWS_ACCESS_KEY_ID
      export INIT_AWS_SECRET_ACCESS_KEY=$AWS_SECRET_ACCESS_KEY
      export INIT_AWS_REGION=$AWS_DEFAULT_REGION

      if [[ ! -z "$SOURCE_ROLE_ARN" ]]; then
        export ROLE_ARN=$SOURCE_ROLE_ARN
        curl -s -o assume-role.sh https://gitlab.com/luktom/ci/-/raw/master/scripts/assume-role.sh && . assume-role.sh
      fi

      if [[ ! -z "$SOURCE_AWS_ACCESS_KEY_ID" && ! -z "$SOURCE_AWS_SECRET_ACCESS_KEY" ]]
      then
        echo "Using credentials from \$SOURCE_AWS_ACCESS_KEY_ID"
        export AWS_ACCESS_KEY_ID=$SOURCE_AWS_ACCESS_KEY_ID
        export AWS_SECRET_ACCESS_KEY=$SOURCE_AWS_SECRET_ACCESS_KEY
      fi

      if [[ ! -z "$SOURCE_AWS_REGION" ]]
      then
        export AWS_DEFAULT_REGION=$SOURCE_AWS_REGION
      fi

      aws sts get-caller-identity

      if [[ ! -z "$SOURCE_REGISTRY_ID" ]]
      then
        echo "Using registry from \$SOURCE_REGISTRY_ID: $REGISTRY_ID"
        aws ecr get-login --no-include-email --region $SOURCE_AWS_REGION --registry-ids $SOURCE_REGISTRY_ID | sh
      else
        aws ecr get-login --no-include-email --region $SOURCE_AWS_REGION | sh
      fi

      if [[ ! -z "$SOURCE_TAG_CMD" ]]
      then
        eval "$SOURCE_TAG_CMD"
      fi

      # reset variables
      export AWS_ACCESS_KEY_ID=$INIT_AWS_ACCESS_KEY_ID
      export AWS_SECRET_ACCESS_KEY=$INIT_AWS_SECRET_ACCESS_KEY
      export AWS_DEFAULT_REGION=$INIT_AWS_REGION

      if [[ ! -z "$TARGET_ROLE_ARN" ]]; then
        export ROLE_ARN=$TARGET_ROLE_ARN
        curl -s -o assume-role.sh https://gitlab.com/luktom/ci/-/raw/master/scripts/assume-role.sh && . assume-role.sh
      fi

      if [[ ! -z "$TARGET_AWS_ACCESS_KEY_ID" && ! -z "$TARGET_AWS_SECRET_ACCESS_KEY" ]]
      then
        echo "Using credentials from \$TARGET_AWS_ACCESS_KEY_ID"
        export AWS_ACCESS_KEY_ID=$TARGET_AWS_ACCESS_KEY_ID
        export AWS_SECRET_ACCESS_KEY=$TARGET_AWS_SECRET_ACCESS_KEY
      fi

      if [[ ! -z "$TARGET_AWS_REGION" ]]
      then
        export AWS_DEFAULT_REGION=$TARGET_AWS_REGION
      fi

      aws sts get-caller-identity

      if [[ ! -z "$TARGET_REGISTRY_ID" ]]
      then
        echo "Using registry from \$TARGET_REGISTRY_ID: $REGISTRY_ID"
        aws ecr get-login --no-include-email --region $TARGET_AWS_REGION --registry-ids $TARGET_REGISTRY_ID | sh
      else
        aws ecr get-login --no-include-email --region $TARGET_AWS_REGION | sh
      fi

      if [[ ! -z "$TARGET_TAG_CMD" ]]
      then
        eval "$TARGET_TAG_CMD"
      fi

      docker pull $SOURCE_REGISTRY_IMAGE:$SOURCE_TAG
      docker tag  $SOURCE_REGISTRY_IMAGE:$SOURCE_TAG $TARGET_REGISTRY_IMAGE:$TARGET_TAG
      docker push $TARGET_REGISTRY_IMAGE:$TARGET_TAG